Page MenuHomePhabricator

Remove EducationProgram in favour of EducationDashboard
Closed, ResolvedPublic

Description

It appears that EducationDashboard is up and running, although some people still use EducationProgram. We are concerned about the lack of maintenance to EducationProgram and several serious bugs that have not been fixed. Can we undeploy this extension?

Event Timeline

Bawolff created this task.Jul 4 2017, 8:17 PM
Restricted Application added subscribers: Base, Aklapper. · View Herald TranscriptJul 4 2017, 8:17 PM
Reedy renamed this task from Removed EducationProgram in favour of EducationDashboard to Remove EducationProgram in favour of EducationDashboard.Jul 4 2017, 8:25 PM

More just me being really explicit in asking, are we there yet? T125618 is tracking all possible features, arguably it could still be open after we move, provided there are non critical features that may be implemented later but don't hold up the move.

Reedy added a subscriber: Reedy.Jul 4 2017, 8:25 PM

Dupe of T125618 ?

Kinda. Though, that could be seen as a subset of this task... As this is actually wanting to undeploy EP

MarcoAurelio added a subscriber: MarcoAurelio.
Mvolz added a comment.Jul 5 2017, 6:50 PM

I mentioned this in another thread, but EducationProgram is also deployed on some Wikiversities (i.e. https://de.wikiversity.org/wiki/Spezial:Version)

Example: https://de.wikiversity.org/wiki/Kurs:Algorithmen_und_Datenstrukturen/Funktionale_Algorithmen

They are using the Course: namespace for many of their courses.

I mentioned this in another thread, but EducationProgram is also deployed on some Wikiversities (i.e. https://de.wikiversity.org/wiki/Spezial:Version)
Example: https://de.wikiversity.org/wiki/Kurs:Algorithmen_und_Datenstrukturen/Funktionale_Algorithmen
They are using the Course: namespace for many of their courses.

Good to know. Programs & Events Dashboard should work fine for Wikiversity, but we'll want to make sure we communicate with all the folks using it when the time comes to push for a transition.

Reedy added a comment.Jul 5 2017, 7:03 PM

Noting, there's nothing wrong with undeploying (without any transitioning) it on specific wikis, if they have no need/don't want it anymore too

Noting, there's nothing wrong with undeploying (without any transitioning) it on specific wikis, if they have no need/don't want it anymore too

As long as the content of the pages is still somehow accessible; otherwise, it's likely to cause some upset.

Reedy added a comment.Jul 5 2017, 7:07 PM

Noting, there's nothing wrong with undeploying (without any transitioning) it on specific wikis, if they have no need/don't want it anymore too

As long as the content of the pages is still somehow accessible; otherwise, it's likely to cause some upset.

Well, surely that's covered by "they don't need/want it anymore". If they need the data... They need the extension ;)

I'll try to summarize the current state Programs & Events Dashboard ( outreachdashboard.wmflabs.org ) as a replacement.

  • P&E Dashboard is currently only maintained by me. Community Tech worked on some of the groundwork for making it better suited for global use, but won't work on it in the future (see https://meta.wikimedia.org/wiki/Talk:Community_Tech/Projects_for_smaller_groups/Notes ). It's working, and stable at the current scale of usage — and can probably comfortably support all of the current users of EP Extension — but increased use by others means that it could grow beyond what the current architecture could support. It has automatic database backups, but is definitely not as reliable and redundant as we'd expect from WMF production. It's probably good enough for the short term, but it's going to be a significant risk in the medium and long term.
  • It can't yet make edits (like the Wiki Ed instance does) to maintain on-wiki records of courses and participants, but the basic framework for that will be in place within the next few months. Outreachy intern @Medhabansal is working on this, but it will require setup of templates and permission from the community on each wiki we enable it for. (Some solution for reflecting course data and relationships on-wiki — so that other users can discover courses that are going on and connect the dots when students start editing — is a hard requirement for some projects currently using the extension.)
  • For wikis that want to retain archives of EP Extension courses, that's outside the scope of P&E Dashboard. Courses can be manually imported by adding all the usernames, but that's only a partial record of the data in the EP extension.
  • @TFlanagan-WMF is the point person for the education team, and can maybe say more about the plans / timeline for preparing current education program users for a transition.
greg added a subscriber: greg.Jul 19 2017, 5:58 PM
Nemo_bis added a subscriber: Nemo_bis.
Aklapper added a subscriber: VMasrour-WMF.

@VMasrour-WMF wrote in https://phabricator.wikimedia.org/T166109#3680479;

The Education Extension is being deprecated and is not receiving any support at this time. [...] It is strongly recommended to move all current and future education programs to the Programs & Events Dashboard in order to receive support (and benefit from its great qualities). https://outreachdashboard.wmflabs.org/

It is not really clear to me how I'd be supposed to "move all programs". Is there a migration guide to link to?

Is "the Programs & Events Dashboard" the same as "EducationDashboard" / Education-Program-Dashboard or are these different things?

Furthermore, T157260 seems to be a competing proposal to this T169676. Who'd have the responsibility to decide which path to take?

The Education team at WMF has invested in and is backing the Programs & Events Dashboard, and has been requesting from education program leaders that they move their programs from the education extension to the P&E Dashboard. As far as i know, most of the education program leaders have found this transition to be very positive. Our team is now finalizing a contract that will ensure stability of and support to this tool. Clearly, the choice has been made and, even though it is not perfect as it stands, the P&E Dashboard is already widely perceived to be the tool of choice.

@VMasrour-WMF: Thanks for your comments.
Looking at wmgUseEducationProgram in https://noc.wikimedia.org/conf/InitialiseSettings.php.txt , the extension is deployed on 'arwiki', 'cawiki', 'cswiki', 'dewikiversity', 'elwiki', 'enwiki', 'enwikinews', 'eswiki', 'fawiki', 'frwikisource', 'hewiki', 'hewiktionary', 'itwikiversity', 'lvwiki', 'mkwiki', 'nlwiki', 'ptwiki', 'ruwiki', 'srwiki', 'svwiki', 'test2wiki', 'ukwiki'.
Where or how is the migration progress of education program leaders tracked? Maybe the extension could already be removed from some sites? How to find out?
And for those education program leaders who have not moved yet, where would they find information how to migrate?

Maybe the extension could already be removed from some sites? How to find out?

I would start by listing wikis where the relevant Special:Log logs don't show any activity for > N months.

Thanks for these tips, we will include on our course of actions.

greg added a comment.EditedOct 17 2017, 6:20 PM

@VMasrour-WMF what is the anticipated timeline for removing EducationProgram from all those wikis? As this extension is not maintained and no one is addressing known security issues, we want it removed from all wikis in a timely manner. (Edit: removed unneeded history)

IKhitron added a subscriber: Esh77.Jan 4 2018, 9:55 PM
demon added a subscriber: demon.Jan 5 2018, 3:50 AM

@VMasrour-WMF what is the anticipated timeline for removing EducationProgram from all those wikis? As this extension is not maintained and no one is addressing known security issues, we want it removed from all wikis in a timely manner. (Edit: removed unneeded history)

New year, let's dust this off. What's the status folks?

Sorry, i apparently missed the October notification.

Actually, we are doing some checks and setting a plan for the final demise of the extension by June 2018 at the latest for those Wikis that are currently using it, and much sooner for those wikis where the extension is not currently in use. We will be presenting a plan regarding this issue for discussion with the education community in the next Education Newsletter.

Your lead contact for this task is @TFlanagan-WMF

Wikimedia UK supports two courses which use the extension, but neither should be running before September/October. What is the earliest the extension would be undeployed on the English Wikipedia?

demon added a comment.Jan 5 2018, 4:02 PM

Thanks for the update @VMasrour-WMF! Do we have a list of which wikis aren't using it already? I'd love to start the process as soon as possible for them.

demon added a comment.Jan 5 2018, 4:04 PM

Wikimedia UK supports two courses which use the extension, but neither should be running before September/October. What is the earliest the extension would be undeployed on the English Wikipedia?

Well if the courses haven't started yet I'd think it'd ideal to not use the extension at all and start using the new setup.

Which begs the question: can we prevent new courses from being started so we're just wrapping up existing ones?

Wikimedia UK supports two courses which use the extension, but neither should be running before September/October. What is the earliest the extension would be undeployed on the English Wikipedia?

@Richard_Nevell_WMUK It would be best to make arrangements to switch those courses over to the P&E Dashboard. I understand the pain of changing tools, but the Education Extension has run its course (pun not intended) and must be deprecated.

@Richard_Nevell_WMUK Please take a look at https://outreachdashboard.wmflabs.org/training and let us know if anything needs improvement there.

Reedy added a comment.EditedJan 5 2018, 6:30 PM

Which begs the question: can we prevent new courses from being started so we're just wrapping up existing ones?

The right would look to be ep-course, but it's for Manage Education Program courses not just adding them... I'd guess the other functionality is probably still wanted at this point.

https://github.com/wikimedia/mediawiki-extensions-EducationProgram/blob/master/includes/rows/Course.php#L399-L470

There's probably some other addition points we might need to deal with... But whacking in a config global, or a new user right there, and then on https://github.com/wikimedia/mediawiki-extensions-EducationProgram/blob/master/includes/rows/Course.php#L400 putting it in the if too... should be easy?

Some other code...

		if ( $this->getUser()->isAllowed( 'ep-course' ) ) {
			$html .= Html::element( 'h2', [], $this->msg( 'ep-institution-add-course' )->text() );
			$html .= Course::getAddNewControl( $this->getContext(), [ 'org' => $org->getId() ] );
		}

@demon Shall I take a crack at it? Right or config global?

@Reedy Just to confirm, are you making it so that no new courses can be created on the extension globally?

@VMasrour-WMF and I are working on a message to post to the individual wikis to direct them to the Programs and Events Dashboard for future cohort tracking needs.

Reedy added a comment.Jan 5 2018, 7:06 PM

@Reedy Just to confirm, are you making it so that no new courses can be created on the extension globally?

That would be the intention. We can of course enable it on some wikis if it's really needed

demon added a comment.Jan 5 2018, 8:54 PM

I don't think we necessarily need to write new code just for this, was curious if it'd be possible (I hadn't even checked yet)

demon removed a subscriber: demon.Feb 19 2019, 10:27 AM
D3r1ck01 closed this task as Resolved.Aug 31 2019, 2:09 PM
D3r1ck01 claimed this task.
D3r1ck01 added a subscriber: D3r1ck01.

Extension has been archived, for more information, see: T214457. Please reopen in case we missed something.

Restricted Application added a project: User-D3r1ck01. · View Herald TranscriptAug 31 2019, 2:09 PM